/*
File: AcceptThread.java
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/

package webwisdom.tango.threads;

import java.lang.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.structures.Registrar;
import netscape.security.PrivilegeManager;

public class AcceptThread implements Runnable {

  private ServerSocket s;
  private Thread th;
  private Registrar reg;
  private boolean noexit;

  public AcceptThread(ServerSocket spar, Registrar regpar) {
    
    s = spar;
    reg = regpar;
    noexit = true;
    th = new Thread(this);
    th.setDaemon(true);
    th.start();
   

  }

  public void run() {

    Socket conn;    

    System.out.println("AcceptThread: thread started");

    PrivilegeManager.enablePrivilege("30Capabilities");

    do {
      try {
	  conn = s.accept();
      } catch(Exception e) {

	System.out.println("AcceptThread Err: " + e);
	e.printStackTrace();
	System.out.println("AcceptThread: terminating thread");
	reg.errorAcc();
	conn = null;
	
      }
      
      if (noexit) 
	reg.handleConnection(conn);
      else
	try {
	  s.close();
	} catch(Exception e) {

	  System.out.println("AcceptThread: " + e);
	  e.printStackTrace();
	}
	
    } while (noexit);
      
    System.out.println("AcceptThread: thread stopped");

  }

 
  public void stop() {
  
    System.out.println("AcceptThread: stop called");
    noexit = false;
   
    try {
      System.out.println("AcceptThread: trying to close");    
      //s.close();
      System.out.println("AcceptThread: socket closed");
    } catch(Exception e) {

      System.out.println("AcceptThread: " + e);
      e.printStackTrace();
    }

  }
}






      
